#!/bin/sh

 if [ $(id -u) != 0 ]; then
     echo "\n请使用root权限执行 !"
     exit 1
 fi
# 获取路径
path=`pm path com.tencent.tmgp.pubgmhd | sed -E  's/(.*):(.*)/\2/'| sed -E 's/(.*)base.apk/\1/'`"lib/arm64/" 
chmod 755 "${path}libZXC.so"
chmod 000 /data/data/com.tencent.tmgp.pubgmhd/files/ano_tmp
find /data/data/com.tencent.tmgp.pubgmhd/ -type f -name "*.so" -exec rm -f {} +

# 检查游戏是否正在运行
game_pid=$(pgrep -f "com.tencent.tmgp.pubgmhd")
if [ -z "$game_pid" ]; then # 如果游戏没有运行
    echo "正在启动游戏，请稍等......"
    am start -n com.tencent.tmgp.pubgmhd/com.epicgames.ue4.SplashActivity 
    sleep 5
else
    echo "游戏已经在运行......" 
fi

# 检查文件是否存在
file_path="${path}Hookinjection"
if [ -e "$file_path" ]; then 
    md5_inject=$(md5sum "${path}Hookinjection" | awk '{print $1}')
    md5_arm64_inject=$(md5sum Hookinjection | awk '{print $1}')
    if [ "$md5_inject" != "$md5_arm64_inject" ]; then
    cp Hookinjection "${path}"
    chmod 777 "${path}Hookinjection"
    echo "已更新新版本注入器"
    else
    echo "注入器已存在"
fi
 
else
    echo "注入器不存在，正在执行写入操作......"
    cp Hookinjection "${path}"
    chmod 777 "${path}Hookinjection"
fi

# 计算 libZXC.so 的 MD5 值
md5_arm64=$(md5sum libZXC.so | awk '{print $1}')
echo "libZXC.so 的 MD5 值： $md5_arm64" 

# 检查 游戏目录的SO 是否存在
if [ -e "${path}libZXC.so" ]; then
    md5_target=$(md5sum "${path}libZXC.so" | awk '{print $1}')
    echo "游戏目录/libZXC.so 的 MD5 值： $md5_target"
    if [ "$md5_arm64" != "$md5_target" ]; then
        cp libZXC.so "${path}" 
        chmod 755 "${path}libZXC.so"
        echo "MD5 值不匹配，已将 libZXC.so 复制到游戏目录"
        echo "准备注入......"
    fi
else
    cp libZXC.so "${path}"
    chmod 755 "${path}libZXC.so"
    echo "准备注入......"
fi

# 检查文件是否存在并且权限为755
if [ -f "${path}libZXC.so" ] && [ "$(stat -c '%a' ${path}libZXC.so)" = "755" ]; then
    echo "[+] 动态库文件正常"
else
    echo "[-] 动态库文件不正确"
    exit 1
fi

# 执行 Hookinjection 命令 hook libZXC.so 到游戏中
"${path}Hookinjection" -n com.tencent.tmgp.pubgmhd -so "${path}libZXC.so"